<html>
  <head>
    <title>Ozon control panel</title>
    <link rel='stylesheet' href='./webcontrols.css'/>
    <script type='text/javascript' src='./webcontrols.js'></script>
  </head>
  <body style='width:800px'>
    <h1>Ozon control panel</h1>
    <div class='button-bar'>
      <button onclick='doRefresh()'>Refresh</button>
      <button onclick='doMove()' style='background-color:yellow'>Move</button>
    </div>
    <div class='button-bar'>
      <label>Ozon desired position</label> 
      <span id='position'>(? ?)</span> <label>and</label>
      <script>webcontrols.addButtonRange("ozon angle", { min: -180, max: 180, width: 150}, function() { showOzon(); });</script>
    </div>
    <img id='img' style='width: 640px;display: block;margin: 10px auto;cursor: pointer;' src='input.png'/>
    <canvas id='where' width='640' height='480'></canvas>
    <canvas id='move' width='640' height='480'></canvas>
   <script>
      webcontrols.addConsole(true);
      // Positions canvas on image
      {
        let img = document.getElementById("img");
        {
          let canvas = document.getElementById("where");
          canvas.style.position = "absolute";
          canvas.style.left = img.offsetLeft;
          canvas.style.top = img.offsetTop;
       }
       {
         let canvas = document.getElementById("move");
          canvas.style.position = "absolute";
          canvas.style.left = img.offsetLeft;
          canvas.style.top = img.offsetTop;
       }
      }
      // Draws ozon value on the image
      function showOzon(value = "", color = "yellow") {
        value = value == '' ? {x: ozon_x, y: ozon_y, a: ozon_angle, r: 20} : JSON.parse(value);
        let canvas = document.getElementById(color == "yellow" ? "move" : "where");
        let context = canvas.getContext("2d");
        context.lineWidth = 2;
        context.strokeStyle = color;
        context.clearRect(0, 0, canvas.width, canvas.height);
        // Draws circle and line
        context.beginPath();
        context.arc(value.x / 2, value.y / 2, value.r / 2, 0, Math.PI * 2, true);
        context.moveTo(value.x / 2, value.y / 2);
        context.lineTo(value.x / 2 + value.r * Math.cos(Math.PI  /  180 * value.a), 
                       value.y / 2 + value.r * Math.sin(Math.PI  /  180 * value.a));
        context.stroke();
      }
      // Defines the desired position
      var ozon_x = undefined, ozon_y = undefined;
      // Defines a clickable mechanism
      document.getElementById("move").onclick = function(e) {
        ozon_x = Math.round(2 * e.offsetX);
        ozon_y = Math.round(2 * e.offsetY);
        document.getElementById("position").innerHTML = "(" + ozon_x + ", " + ozon_y + ")";
        showOzon();
      }
      function doRefresh() {
        webcontrols.curl("@/_ccwrapper", "command=i", "POST", function(value) {
        let path = value.replace(new RegExp(".*'([^']*)'.*"), "$1"), src = urlRPi + "/" + path + "/input.png";
          document.getElementById("img").src = src;
          webcontrols.curl("@/_ccwrapper", "command=o?", "POST", function(value) {
            console.log(value);
            value = value.replace(new RegExp(".*({[^}]*}).*"), "$1");
            console.log(value);
            showOzon(value, "red");
          });
        });     
      }
      function doMove() {
        if (ozon_x != undefined && ozon_y != undefined)
          webcontrols.curl("@/_ccwrapper", "command=o"+ozon_x+","+ozon_y+","+ozon_angle, "POST", function(value) {
            doRefresh();
          });
      }
    </script>
  </body>
</html>
